package cn.com.infosec.mobile.android.xlog.internal.util;

import android.support.annotation.Keep;
import cn.com.infosec.mobile.android.xlog.XLog;
import java.io.PrintWriter;
import java.io.StringWriter;
import java.net.UnknownHostException;

@Keep
public class StackTraceUtil {
   private static final String XLOG_STACK_TRACE_ORIGIN;

   public static String getStackTraceString(Throwable tr) {
      if (tr == null) {
         return "";
      } else {
         for(Throwable var1 = tr; var1 != null; var1 = var1.getCause()) {
            if (var1 instanceof UnknownHostException) {
               return "";
            }
         }

         StringWriter var2;
         StringWriter var10000 = var2 = new StringWriter;
         var10000.<init>();
         PrintWriter var10001 = new PrintWriter(var2);
         tr.printStackTrace(var10001);
         var10001.flush();
         return var10000.toString();
      }
   }

   public static StackTraceElement[] getCroppedRealStackTrack(StackTraceElement[] stackTrace, String stackTraceOrigin, int maxDepth) {
      return cropStackTrace(getRealStackTrack(stackTrace, stackTraceOrigin), maxDepth);
   }

   private static StackTraceElement[] getRealStackTrack(StackTraceElement[] stackTrace, String stackTraceOrigin) {
      int var2 = 0;

      int var3;
      for(int var4 = (var3 = stackTrace.length) - 1; var4 >= 0; --var4) {
         String var5;
         if ((var5 = stackTrace[var4].getClassName()).startsWith(XLOG_STACK_TRACE_ORIGIN) || stackTraceOrigin != null && var5.startsWith(stackTraceOrigin)) {
            var2 = var4 + 1;
            break;
         }
      }

      int stackTraceOrigin1;
      StackTraceElement[] var7;
      StackTraceElement[] var10000 = var7 = new StackTraceElement[stackTraceOrigin1 = var3 - var2];
      System.arraycopy(stackTrace, var2, var7, 0, stackTraceOrigin1);
      return var10000;
   }

   private static StackTraceElement[] cropStackTrace(StackTraceElement[] callStack, int maxDepth) {
      int var2 = callStack.length;
      if (maxDepth > 0) {
         var2 = Math.min(maxDepth, var2);
      }

      StackTraceElement[] maxDepth1;
      StackTraceElement[] var10000 = maxDepth1 = new StackTraceElement[var2];
      System.arraycopy(callStack, 0, maxDepth1, 0, var2);
      return var10000;
   }

   static {
      String var10000 = XLog.class.getName();
      XLOG_STACK_TRACE_ORIGIN = var10000.substring(0, var10000.lastIndexOf(46) + 1);
   }
}
